// Name:

using System;

namespace Test3
{
	public class MeasuredValues
	{
		const int Nmax = 50;

		double [] list;
		int count;
		double meanValue;
		double variance;
		double min;
		double max;

		public MeasuredValues()
		{
			list = new double[Nmax];
			count = 0;
		}

		public int Count { get { return count; } }
		public double Variance { get { return variance; } }

		public bool Add (double newValue)
		{
			if (count < Nmax)
			{
				list[count] = newValue;
				count++;
				CalculateStatistic();
				return true;
			}
			else
				return false;
		}

		public void RemoveAt (int i)
		{
			for (int j = i; j < count - 1; j++)
				list[j] = list[j+1];
			count--;
			CalculateStatistic();
		}

		public double GetItem(int i)
		{
			if (i >= 0 && i < count)
				return list[i];
			else
				return double.NaN;  // means not defined 
		}

		public void Clear()
		{
			count = 0;
			meanValue = Double.NaN;
			variance = Double.NaN;
			min = Double.NaN;
			max = Double.NaN;
		}

		public void CalculateStatistic()
		{
			if (count < 1) 
				return;
			meanValue = 0.0;
			variance = CalculateVariance();
			min = 0.0;
			max = 0.0;
		}
	
		double CalculateVariance()
		{
			double sum2 = 0.0;
			for (int i = 0; i < count; i++)
				sum2 += Math.Pow(list[i] - meanValue, 2);
			return sum2 / count;
		}

	}
}
